Option Explicit

Sub Pruebas()
	ExportarPDF()
End Sub

Sub MostrarFechayHora()
Dim sMensaje As String

	sMensaje = Format( Now(), "dddd dd \d\e mmmm \d\el yyyy " & Chr(13) & _
                                "y \son la\s HH \ho\ra\s con mm \minuto\s"

	MsgBox sMensaje, 64,"Hoy es"
                
End Sub

Sub MostrarMensaje()
Dim sMensaje As String

	sMensaje = "No te olvides de guardar tu documento"
        
	MsgBox sMensaje, 64,"Creando documento"
                
End Sub

Sub AccediendoAOpenOffice1()
Dim appOpenOffice As Object
        
	appOpenOffice = createUnoService( "com.sun.star.frame.Desktop" )        
	
	'appOpenOffice = StarDesktop
	
End Sub

Sub AccediendoAOpenOffice2()
Dim appOpenOffice As Object
Dim oActivo As Object

	'Inicializamos una variable con el servicio com.sun.star.frame.Desktop  
   appOpenOffice = StarDesktop
        
   'Obtenemos una referencia al componente activo
   oActivo = appOpenOffice.CurrentComponent

   'Mostramos el tipo de componente
   MsgBox oActivo.Identifier

End Sub

Sub AccediendoAOpenOffice3()
Dim appOpenOffice As Object
Dim oActivo As Object

	'Inicializamos una variable con el servicio com.sun.star.frame.Desktop  
   appOpenOffice = StarDesktop
        
   'Obtenemos una referencia al componente activo
   oActivo = appOpenOffice.CurrentComponent

   'Mostramos el tipo de componente
   Select Case oActivo.Identifier
   	Case "com.sun.star.sheet.SpreadsheetDocument"
        		MsgBox "Soy una hoja de calculo"
		Case "com.sun.star.presentation.PresentationDocument"
        		MsgBox "Soy una presentacion"           
		Case "com.sun.star.drawing.DrawingDocument"
        		MsgBox "Soy un dibujo"          
		Case "com.sun.star.formula.FormulaProperties"
        		MsgBox "Soy una formula"                
   	Case "com.sun.star.text.TextDocument"
			MsgBox "Soy un documento de texto"      
	End Select

End Sub

Sub AccediendoAOpenOffice4()
Dim oActivo As Object
        
	'Obtenemos una referencia al componente activo
	oActivo = StarDesktop.CurrentComponent

	'Mostramos el tipo de componente
	MsgBox oActivo.ImplementationName

End Sub

Sub AccediendoAOpenOffice5()
Dim oActivo As Object
Dim bImplementaServicio As Boolean

        oActivo = StarDesktop.CurrentComponent
        
        bImplementaServicio = oActivo.supportsService("com.sun.star.sheet.SpreadsheetDocument")
        
        If bImplementaServicio Then
                MsgBox "Soy una hoja de calculo"
        Else
                MsgBox "NO soy una hoja de calculo"
        End If

End Sub

Sub AccediendoAOpenOffice6()
Dim oActivo As Object

        oActivo = StarDesktop.CurrentComponent
                
        If oActivo.supportsService("com.sun.star.sheet.SpreadsheetDocument") Then
                MsgBox "Soy una hoja de calculo"
        ElseIf oActivo.supportsService("com.sun.star.text.TextDocument") Then
                MsgBox "Soy un documento de texto"
        ElseIf oActivo.supportsService("com.sun.star.presentation.PresentationDocument") Then
                MsgBox "Soy una presentacion"
        ElseIf oActivo.supportsService("com.sun.star.drawing.DrawingDocument") Then
                MsgBox "Soy un dibujo"
        ElseIf oActivo.supportsService("com.sun.star.sdb.OfficeDatabaseDocument") Then
                MsgBox "Soy una base de datos"
        ElseIf oActivo.supportsService("com.sun.star.formula.FormulaProperties") Then
                MsgBox "Soy una formula"
        ElseIf oActivo.supportsService("com.sun.star.script.BasicIDE") Then
                MsgBox "Soy el editor de codigo IDE"            
        Else
                MsgBox "NO se que tipo de documento soy"
        End If

End Sub

Sub AccediendoAOpenOffice7()
Dim oActivo As Object
Dim mServicios() As String
Dim co1 As Byte
        
        'Obtenemos una referencia al componente activo
        oActivo = StarDesktop.CurrentComponent

        'Obtenemos una matriz con los servicios que implementa
        mServicios() = oActivo.SupportedServiceNames
        'Y mostramos el nombre de cada servicio
        For co1 = LBound( mServicios() ) To UBound( mServicios() )      
                MsgBox mServicios( co1 )                
        Next
        
End Sub

Sub AccediendoAOpenOffice8()
Dim oActivo As Object
Dim bImplementaServicio As Boolean

        oActivo = StarDesktop.CurrentComponent
    
        bImplementaServicio = oActivo.supportsService("com.sun.star.document.OfficeDocument")
        
        If bImplementaServicio Then
                MsgBox "Verdad que si esta implementado el servicio"
        Else
                MsgBox "NO esta implementado el servicio"
        End If

End Sub

Sub AccediendoAOpenOffice9()
Dim oActivo As Object
Dim mServicios() As String
Dim co1 As Byte
        
        oActivo = StarDesktop.CurrentComponent
        mServicios() = oActivo.getSupportedServiceNames()
        For co1 = LBound( mServicios() ) To UBound( mServicios() )      
                MsgBox mServicios( co1 )                
        Next

End Sub

Sub Controlando_OpenOffice1()
Dim oDocumentos As Object
Dim oDocumento As Object
Dim oEnumeraDocumentos As Object

        'Accedemos a todos los documentos actualmente abiertos
        oDocumentos = StarDesktop.getComponents()
        'Enumeramos cada uno
        oEnumeraDocumentos = oDocumentos.createEnumeration()
        'hasMoreElements devuelve verdadero (True) mientras haya elementos
        Do While oEnumeraDocumentos.hasMoreElements()
                'Nos desplazamos al siguiente elemento y lo asignamos
                oDocumento = oEnumeraDocumentos.nextElement()
                'Mostramos el tipo de documento
                MsgBox "Soy un documento de " & TipoDocumento( oDocumento )
        Loop
        
End Sub

Function TipoDocumento(ByRef Documento As Object) As String
Dim sAplicacion As String

        If Documento.supportsService("com.sun.star.sheet.SpreadsheetDocument") Then
                sAplicacion = "Calc"
        ElseIf Documento.supportsService("com.sun.star.text.TextDocument") Then
                sAplicacion = "Writer"
        ElseIf Documento.supportsService("com.sun.star.presentation.PresentationDocument") Then
                sAplicacion = "Impress"
        ElseIf Documento.supportsService("com.sun.star.drawing.DrawingDocument") Then
                sAplicacion = "Draw"
        ElseIf Documento.supportsService("com.sun.star.sdb.OfficeDatabaseDocument") Then
                sAplicacion = "Base"
        ElseIf Documento.supportsService("com.sun.star.formula.FormulaProperties") Then
                sAplicacion = "Math"
        ElseIf Documento.supportsService("com.sun.star.script.BasicIDE") Then
                sAplicacion = "Basic"
        Else
                sAplicacion = "Desconocido"
        End If
        
        TipoDocumento = sAplicacion

End Function

Sub Controlando_OpenOffice2()
Dim oDocumentos As Object
Dim oDocumento As Object
Dim oEnumeraDocumentos As Object
Dim co1 As Integer

        oDocumentos = StarDesktop.getComponents()
        oEnumeraDocumentos = oDocumentos.createEnumeration()
        Do While oEnumeraDocumentos.hasMoreElements()
                oDocumento = oEnumeraDocumentos.nextElement()
                'Verificamos que sea un archivo de Calc
                If TipoDocumento( oDocumento ) = "Calc" Then
                        'Si no ha sido modificado o los cambios ya estan guardados
                        'el metodo isModified devolvera False
                        If Not oDocumento.isModified() Then
                                'el metodo dispose cierra el archivo
						oDocumento.dispose()
                                co1 = co1 + 1
                        End if
                End If                          
        Loop
        MsgBox "Se cerraron un total de " & CStr(co1) & " archivos de Calc"
        
End Sub

Sub ConsultandoObjetos1()
Dim sDatos As String

        MsgBox StarDesktop.Dbg_Properties
        MsgBox StarDesktop.Dbg_Methods
        MsgBox StarDesktop.Dbg_SupportedInterfaces
        
End Sub

Sub ConsultandoObjetos2()
Dim sDatos As String

        MsgBox StarDesktop.getCurrentComponent().Dbg_Properties
        MsgBox StarDesktop.getCurrentComponent().Dbg_Methods
        MsgBox StarDesktop.getCurrentComponent().Dbg_SupportedInterfaces
        
End Sub

Sub ConsultandoObjetos3()
    BasicLibraries.LoadLibrary( "Tools" )
	Call WritedbgInfo( StarDesktop.getCurrentComponent() )
End Sub

Sub CreandoNuevosDocumentos1()
Dim sRuta As String
Dim mArg()
Dim oNuevoDocumento As Object

        sRuta = "private:factory/scalc"
        oNuevoDocumento = StarDesktop.loadComponentFromURL( sRuta, "_default", 0, mArg() )

End Sub

Sub CreandoNuevosDocumentos2()
Dim sRuta As String
Dim mArg()
Dim oNuevoDocumento As Object

        sRuta = "private:factory/swriter"
        oNuevoDocumento = StarDesktop.loadComponentFromURL( sRuta, "_default", 0, mArg() )

End Sub

Sub CreandoNuevosDocumentos3()
Dim sRuta As String
Dim mArg()
Dim oNuevoDocumento As Object

        sRuta = "private:factory/simpress"
        oNuevoDocumento = StarDesktop.loadComponentFromURL( sRuta, "_default", 0, mArg() )

        sRuta = "private:factory/sdraw"
        oNuevoDocumento = StarDesktop.loadComponentFromURL( sRuta, "_default", 0, mArg() )

        sRuta = "private:factory/smath"
        oNuevoDocumento = StarDesktop.loadComponentFromURL( sRuta, "_default", 0, mArg() )

End Sub

Sub CreandoNuevosDocumentos4()
Dim sRuta As String
Dim mArg()
Dim oNuevoDocumento As Object

        sRuta = "private:factory/sbase"
        oNuevoDocumento = StarDesktop.loadComponentFromURL( sRuta, "_default", 0, mArg() )

End Sub

Sub CreandoBaseDeDatos1()
Dim oBDServicio As Object
Dim oBDNueva As Object
Dim sRuta As String
Dim mArg()

	'Ruta y nombre donde quedara guardada la base de datos
	sRuta = "/home/mau/Mi_Base_Datos.odb"
	'Creamos el servicio que nos permite manipular bases de datos
	oBDServicio = createUnoService( "com.sun.star.sdb.DatabaseContext" )
	'Creamos una nueva instancia de una base de datos
	oBDNueva = oBDServicio.createInstance()
	'Establecemos el tipo de base
	oBDNueva.URL = "sdbc:embedded:hsqldb"
	'Y la guardamos
	oBDNueva.DatabaseDocument.storeAsURL( sRuta, mArg() )

End Sub

Sub RutasDeArchivos1()
Dim sRuta As String

        'Establecemos una ruta
        sRuta = "/home/mau/Mi archivo de Calc.ods"
        'Y la mostramos
        MsgBox sRuta
        
        'La convertimos al formato URL
        sRuta = ConvertToUrl( "/home/mau/Mi archivo de Calc.ods" )
        'Y vemos el resultado
        MsgBox sRuta
        
        'Regresamos al formato local
        sRuta = ConvertFromUrl( sRuta )
        'Y comprobamos que es correcto
        MsgBox sRuta
                

End Sub

Sub DocumentoActivoMostrarDatos()
Dim sRutaURL As String
Dim sRutaCompleta As String
Dim sRuta As String
Dim sNombre As String

        'Referencia al documento activo
        sRutaURL = ThisComponent.getURL()
        'Convertimos la ruta URL en formato local
		sRutaCompleta = ConvertFromUrl( sRutaURL )
		'Obtenemos solo el nombre del archivo
		sNombre = FileNameOutOfPath( sRutaURL )
		'Obtenemos el directorio donde esta el archivo
        sRuta = DirectoryNameoutofPath(sRutaCompleta, GetPathSeparator())
        'Mostramos los resultados
        MsgBox sRutaCompleta & Chr(13) & Chr(13) & sNombre & Chr(13) & Chr(13) & sRuta
        
End Sub

Sub AbriendoDocumentos1()
Dim sRuta As String
Dim mArg()
Dim oDocumento As Object

        'Reemplaza esta ruta por la ruta de tu archivo
        sRuta = ConvertToUrl( "/home/mau/Mi archivo de Calc.ods" )
        oDocumento = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mArg() )

End Sub

Sub AbriendoDocumentos2()
Dim sRuta As String
Dim mArg()
Dim oDocumento As Object

	sRuta = ConvertToUrl( "/home/mau/miPlantilla.ots" )
	oDocumento = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mArg() )

End Sub

Sub AbriendoDocumentos3()
Dim sRuta As String
Dim mOpciones(0) As New "com.sun.star.beans.PropertyValue"
Dim oDoc As Object

        mOpciones(0).Name = "AsTemplate"
        mOpciones(0).Value = False
        
        sRuta = ConvertToUrl( "/home/mau/miPlantilla.ots" )
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )

End Sub

Sub AbriendoDocumentos4()
Dim sRuta As String
Dim mOpciones(0) As New "com.sun.star.beans.PropertyValue"
Dim oDoc As Object

        mOpciones(0).Name = "AsTemplate"
        mOpciones(0).Value = True
        
        sRuta = ConvertToUrl( "/home/mau/Mi archivo de Writer.odt" )
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )

End Sub

Sub AbriendoDocumentos5()
Dim sRuta As String
Dim mOpciones(0) As New "com.sun.star.beans.PropertyValue"
Dim oDoc As Object

        mOpciones(0).Name = "ReadOnly"
        mOpciones(0).Value = True
        
        sRuta = ConvertToUrl( "/home/mau/Mi archivo de Writer.odt" )
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )

End Sub

Sub AbriendoDocumentos6()
Dim sRuta As String
Dim mOpciones(0) As New "com.sun.star.beans.PropertyValue"
Dim oDoc As Object

		'La contraseña más segura
        mOpciones(0).Name = "Password"
        mOpciones(0).Value = "abrete"
        
        sRuta = ConvertToUrl( "/home/mau/Mi archivo de Draw.odg" )
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )

End Sub

Sub AbriendoDocumentos7()
Dim sRuta As String
Dim mOpciones(1) As New "com.sun.star.beans.PropertyValue"
Dim oDoc As Object

        mOpciones(0).Name = "ReadOnly"
        mOpciones(0).Value = True
        mOpciones(1).Name = "Password"
        mOpciones(1).Value = "abrete"
                
        sRuta = ConvertToUrl( "/home/mau/Mi archivo de Draw.odg" )
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )
End Sub

Sub AbriendoDocumentos8()
Dim sRuta As String
Dim mOpciones(0) As New "com.sun.star.beans.PropertyValue"
Dim oDoc As Object
Dim sContra As String
        
        sContra = Trim( InputBox( "Introduce la contraseña de apertura" ) )
        mOpciones(0).Name = "Password"
        mOpciones(0).Value = sContra

        sRuta = ConvertToUrl( "/home/mau/Mi archivo de Draw.odg" )

		'Verificamos que exista el archivo        
        If Len(Dir(sRuta)) > 0 Then                
                oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )
        Else
                MsgBox "El archivo no existe"
        End If
End Sub

Sub AbriendoDocumentos9()
Dim sRuta As String
Dim mOpciones(0) As New "com.sun.star.beans.PropertyValue"
Dim oDoc As Object

        sRuta = ConvertToUrl( "/home/mau/Campamentos.doc" )
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )

        sRuta = ConvertToUrl( "/home/mau/Renacimiento.htm" )
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )

        sRuta = ConvertToUrl( "/home/mau/datos.xls" )
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )

End Sub

Sub AbriendoDocumentos10()
Dim sRuta As String
Dim mOpciones(0) As New "com.sun.star.beans.PropertyValue"
Dim oDoc As Object

        mOpciones(0).Name = "MacroExecutionMode"
        mOpciones(0).Value = 4
        
        sRuta = ConvertToUrl( "/home/mau/Mi archivo de Calc.ods" )
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )
End Sub

Sub AbriendoDocumentos11()
Dim sRuta As String
Dim mOpciones(0) As New "com.sun.star.beans.PropertyValue"
Dim oDoc As Object

        mOpciones(0).Name = "StartPresentation"
        mOpciones(0).Value = True
        
        sRuta = ConvertToUrl( "/home/mau/Mi archivo de Impress.odp" )
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )

End Sub

Sub AbriendoGuardandoDocumentos1()
Dim sRuta As String
Dim mOpciones(0) As New "com.sun.star.beans.PropertyValue"
Dim oDoc As Object
        
        sRuta = ConvertToUrl( "/home/mau/Mi archivo de Calc.ods" )
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )

        'AQUI va todo el codigo que quieras para manipular el archivo

        MsgBox "Archivo abierto y modificado correctamente, presione Aceptar para guardar y cerrar"

        'Guardamos los cambios
        oDoc.store()
        'Cerramos el archivo
        oDoc.close(True)

End Sub

Sub AbriendoGuardandoDocumentos2()
Dim sRuta As String
Dim mOpciones(0) As New "com.sun.star.beans.PropertyValue"
Dim oDoc As Object
         
        sRuta = "private:factory/scalc"
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )

        MsgBox oDoc.hasLocation()

        sRuta = ConvertToUrl( "/home/mau/Mi archivo de Calc.ods" )
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )
        
        MsgBox oDoc.hasLocation()
        
End Sub

Sub EstaModificado()        
	MsgBox ThisComponent.isModified()
End Sub

Sub AbriendoGuardandoDocumentos3()
Dim sRuta As String
Dim mOpciones(0) As New "com.sun.star.beans.PropertyValue"
Dim oDoc As Object
        
        sRuta = "private:factory/scalc"
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )

        MsgBox oDoc.isReadOnly()

        	mOpciones(0).Name = "ReadOnly"
		mOpciones(0).Value = True

        sRuta = ConvertToUrl( "/home/mau/Mi archivo de Calc.ods" )
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )
        
        MsgBox oDoc.isReadOnly()

End Sub

Sub AbriendoGuardandoDocumentos4()
Dim sRuta As String
Dim mOpciones(0) As New "com.sun.star.beans.PropertyValue"
Dim oDoc As Object
        
        sRuta = "private:factory/scalc"
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )

        'Establecemos la ruta y nombre donde se guardara el archivo
        sRuta = ConvertToUrl( "/home/mau/Archivo de Calc.ods" )
        'Guardamos el archivo
        oDoc.storeAsURL( sRuta, mOpciones() )
        
End Sub

Sub AbriendoGuardandoDocumentos5()
Dim sRuta As String
Dim mOpciones(0) As New "com.sun.star.beans.PropertyValue"
Dim oDoc As Object

        sRuta = "private:factory/scalc"
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )

        sRuta = ConvertToUrl( "/home/mau/Archivo de Calc.ods" )
        If Len( Dir( sRuta )) = 0 Then          
                'Guardamos el archivo
                oDoc.storeAsURL( sRuta, mOpciones() )
        Else
                MsgBox "El archivo ya existe, no se ha guardado el nuevo archivo"
        End If
        
End Sub

Sub AbriendoGuardandoDocumentos6()
Dim sRuta As String
Dim mOpciones(0) As New "com.sun.star.beans.PropertyValue"
Dim oDoc As Object

        sRuta = "private:factory/scalc"
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )

        'Como vez no tengo mucha imaginacion
        mOpciones(0).Name = "Password"
        mOpciones(0).Value = "abrete"
        sRuta = ConvertToUrl( "/home/mau/Archivo de Calc.ods" )
        oDoc.storeAsURL( sRuta, mOpciones() )
        
End Sub

Sub AbriendoGuardandoDocumentos7()
Dim sRuta As String
Dim mOpciones(0) As New "com.sun.star.beans.PropertyValue"
Dim oDoc As Object

        sRuta = "private:factory/swriter"
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )

        'Establecemos el filtro a documentos tipo DOC
        mOpciones(0).Name = "FilterName"
        mOpciones(0).Value = "MS Word 97"
        sRuta = ConvertToUrl( "/home/mau/Archivo de Word.doc" )
        oDoc.storeAsURL( sRuta, mOpciones() )
        
End Sub

Sub AbriendoGuardandoDocumentos8()
Dim sRuta As String
Dim mOpciones(0) As New "com.sun.star.beans.PropertyValue"
Dim oDoc As Object

        sRuta = ConvertToUrl( "/home/mau/Mi archivo de Calc.ods" )
        oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )

        sRuta = ConvertToUrl( "/home/mau/Nuevo archivo Calc.ods" )
        oDoc.storeAsURL( sRuta, mOpciones() )
        
End Sub

Sub AbrirArchivo1()
Dim oDlgAbrirArchivo as Object
Dim mArchivo() As String
Dim mOpciones()
Dim sRuta As String
Dim oDoc As Object

        'Creamos el servicio necesario
        oDlgAbrirArchivo = CreateUnoService ("com.sun.star.ui.dialogs.FilePicker")
        'Establecemos el titulo del cuadro de dialogo
        oDlgAbrirArchivo.setTitle("Selecciona el archivo a abrir")
        'Con el metodo .Execute() mostramos el cuadro de dialogo
        'Si el usuario presiona Abrir el metodo devuelve 1 que podemos evaluar como Verdadero (True)
        'Si presiona Cancelar devuelve 0
        If oDlgAbrirArchivo.Execute() Then
                'De forma predeterminada, solo se puede seleccionar un archivo
                'pero devuelve una matriz de todos modos con la ruta completa
                'del archivo en formato URL
                mArchivo() = oDlgAbrirArchivo.getFiles()
                'El primer elemento de la matriz es el archivo seleccionado
                sRuta = mArchivo(0)
                'Y lo abrimos
                oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )
        Else
                'Si el usuario presiona Cancelar
                MsgBox "Proceso cancelado"
        End If
        
End Sub

Sub AbrirArchivo2()
Dim oDlgAbrirArchivo as Object
Dim mArchivos() As String
Dim mOpciones()
Dim co1 As Integer

        oDlgAbrirArchivo = CreateUnoService ("com.sun.star.ui.dialogs.FilePicker")
        oDlgAbrirArchivo.setTitle("Selecciona los archivos a abrir")
        'Establecemos que se puedan seleccionar mas de un archivo
        oDlgAbrirArchivo.setMultiSelectionMode(True)
        If oDlgAbrirArchivo.Execute() Then
                mArchivos() = oDlgAbrirArchivo.getSelectedFiles()
                'Mostramos los archivos seleccionados
                For co1 = LBound( mArchivos() ) To UBound( mArchivos() )
                        MsgBox ConvertFromUrl( mArchivos(co1) )
                Next
                'Te queda de tarea abrir todos los archivos
                'oDoc = StarDesktop.loadComponentFromURL( sRuta, "_blank", 0, mOpciones() )
        Else
                MsgBox "Proceso cancelado"
        End If
        
End Sub

Sub GuardarArchivo1()
Dim oDlgGuardarArchivo as Object
Dim mDlgOpciones()
Dim mArchivo() As String
Dim mOpciones()

        'Usamos el mismo servicio para abrir archivos, pues es el mismo cuadro de dialogo
        oDlgGuardarArchivo = CreateUnoService ("com.sun.star.ui.dialogs.FilePicker")
        'Establecemos que nos muestre el cuadro de dialogo Guardar Como con las
        'casillas de verificacion Autoextension y guardar con contraseña
        'com.sun.star.ui.dialogs.TemplateDescription.FILESAVE_AUTOEXTENSION_PASSWORD = 2
        mDlgOpciones() = Array(2)
        With oDlgGuardarArchivo
                'Iniciamos el cuadro de dialogo con las opciones seleccionadas
                .Initialize ( mDlgOpciones() )
                'Agreamos filtros de archivos
                .AppendFilter( "All files (*.*)", "*.*" )
                .AppendFilter( "Documento de Texto ODF (.odt)", "*.odt" )
                .AppendFilter( "Hoja de calculo ODF (.ods)", "*.ods" )
        End With
        
        'Lo mostramos
        If oDlgGuardarArchivo.Execute() Then
                mArchivo() = oDlgGuardarArchivo.getFiles()
                'Solo te muestro la ruta y nombre de archivo seleccionado
                'Solo te resta guardar el archivo
                MsgBox ConvertFromUrl( mArchivo(0) )
        Else
                MsgBox "Proceso cancelado"
        End If

End Sub

Sub ExportarPDF()
Dim oDoc As Object
Dim sTipoDoc As String
Dim mOpciones(0) As New "com.sun.star.beans.PropertyValue"
dim sRuta As string

	BasicLibraries.LoadLibrary( "Tools" )
        'Referencia al documento desde donde se llama la macro
        oDoc = ThisComponent
        
        'Obtenemos el tipo de documento, esta función ya la usamos
        sTipoDoc = TipoDocumento( oDoc )
        
        'Solo se pueden exportar (por ahora)
        Select Case sTipoDoc
                'los siguiente documentos
                Case "Calc", "Writer", "Draw", "Impress", "Math"
                        'Establecemos el tipos de filtro
                        mOpciones(0).Name = "FilterName"
                        'Contruimos el filtro correcto PDF para cada aplicacion
                        mOpciones(0).Value = LCase(sTipoDoc) & "_pdf_Export"

                        'Construimos la ruta correcta, usamos el mismo directorio
                        'y nombre del archivo, solo agregamos la extension PDF
                        sRuta = GetFileNameWithoutExtension( oDoc.getUrl ) & ".pdf"

                        'Guardamos el archivo
                        oDoc.storeToURL( sRuta, mOpciones() )
                Case Else
                        MsgBox "Aplicacion no soportada"
        End Select

End Sub

